Crazy Eddies GUI System: CEGUI::MultiLineEditbox Class Reference

Crazy Eddies GUI System 0.7.6

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | Static Protected Attributes
CEGUI::MultiLineEditbox Class Reference

Base class for the multi-line edit box widget. More...

Inheritance diagram for CEGUI::MultiLineEditbox:
[legend]
Collaboration diagram for CEGUI::MultiLineEditbox:
[legend]

List of all members.

## Classes
struct | LineInfo
| struct used to store information about a formatted line within the paragraph. More...
## Public Types
typedef std::vector< LineInfo > | LineList
| Type for collection of LineInfos.
## Public Member Functions
bool | hasInputFocus (void) const
| return true if the edit box has input focus.
bool | isReadOnly (void) const
| return true if the edit box is read-only.
size_t | getCaratIndex (void) const
| return the current position of the carat.
size_t | getSelectionStartIndex (void) const
| return the current selection start point.
size_t | getSelectionEndIndex (void) const
| return the current selection end point.
size_t | getSelectionLength (void) const
| return the length of the current selection (in code points / characters).
size_t | getMaxTextLength (void) const
| return the maximum text length set for this edit box.
bool | isWordWrapped (void) const
| Return whether the text in the edit box will be word-wrapped.
Scrollbar * | getVertScrollbar () const
| Return a pointer to the vertical scrollbar component widget for this MultiLineEditbox.
bool | isVertScrollbarAlwaysShown (void) const
| Return whether the vertical scroll bar is always shown.
Scrollbar * | getHorzScrollbar () const
| Return a pointer to the horizontal scrollbar component widget for this MultiLineEditbox.
Rect | getTextRenderArea (void) const
| Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.
const LineList & | getFormattedLines (void) const
size_t | getLineNumberFromIndex (size_t index) const
| Return the line number a given index falls on with the current formatting. Will return last line if index is out of range.
virtual void | initialiseComponents (void)
| Initialise the Window based object ready for use.
void | setReadOnly (bool setting)
| Specify whether the edit box is read-only.
void | setCaratIndex (size_t carat_pos)
| Set the current position of the carat.
void | setSelection (size_t start_pos, size_t end_pos)
| Define the current selection for the edit box.
void | setMaxTextLength (size_t max_len)
| set the maximum text length for this edit box.
void | ensureCaratIsVisible (void)
| Scroll the view so that the current carat position is visible.
void | setWordWrapping (bool setting)
| Set whether the text will be word wrapped or not.
void | setShowVertScrollbar (bool setting)
| Set whether the vertical scroll bar should always be shown.
void | setSelectionBrushImage (const Image *image)
const Image * | getSelectionBrushImage () const
| MultiLineEditbox (const String &type, const String &name)
| Constructor for the MultiLineEditbox base class.
virtual | ~MultiLineEditbox (void)
| Destructor for the MultiLineEditbox base class.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const String | WidgetTypeName
| Window factory name.
static const String | EventReadOnlyModeChanged
static const String | EventWordWrapModeChanged
static const String | EventMaximumTextLengthChanged
static const String | EventCaratMoved
static const String | EventTextSelectionChanged
static const String | EventEditboxFull
static const String | EventVertScrollbarModeChanged
static const String | EventHorzScrollbarModeChanged
static const String | VertScrollbarNameSuffix
| Widget name suffix for the vertical scrollbar component.
static const String | HorzScrollbarNameSuffix
| Widget name suffix for the horizontal scrollbar component.
## Protected Member Functions
void | formatText (void)
| Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.
void | formatText (const bool update_scrollbars)
| Format the text into lines as dictated by the formatting options.
size_t | getNextTokenLength (const String &text, size_t start_idx) const
| Return the length of the next token in String text starting at index start_idx.
void | configureScrollbars (void)
| display required integrated scroll bars according to current state of the edit box and update their values.
size_t | getTextIndexFromPosition (const Point &pt) const
| Return the text code point index that is rendered closest to screen position pt.
void | clearSelection (void)
| Clear the current selection setting.
void | eraseSelectedText (bool modify_text=true)
| Erase the currently selected text.
void | handleBackspace (void)
| Processing for backspace key.
void | handleDelete (void)
| Processing for Delete key.
void | handleCharLeft (uint sysKeys)
| Processing to move carat one character left.
void | handleWordLeft (uint sysKeys)
| Processing to move carat one word left.
void | handleCharRight (uint sysKeys)
| Processing to move carat one character right.
void | handleWordRight (uint sysKeys)
| Processing to move carat one word right.
void | handleDocHome (uint sysKeys)
| Processing to move carat to the start of the text.
void | handleDocEnd (uint sysKeys)
| Processing to move carat to the end of the text.
void | handleLineHome (uint sysKeys)
| Processing to move carat to the start of the current line.
void | handleLineEnd (uint sysKeys)
| Processing to move carat to the end of the current line.
void | handleLineUp (uint sysKeys)
| Processing to move carat up a line.
void | handleLineDown (uint sysKeys)
| Processing to move carat down a line.
void | handleNewLine (uint sysKeys)
| Processing to insert a new line / paragraph.
void | handlePageUp (uint sysKeys)
| Processing to move caret one page up.
void | handlePageDown (uint sysKeys)
| Processing to move caret one page down.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.
bool | handle_scrollChange (const EventArgs &args)
| Internal handler that is triggered when the user interacts with the scrollbars.
bool | handle_vertScrollbarVisibilityChanged (const EventArgs &)
virtual bool | validateWindowRenderer (const String &name) const
| Function used in checking if a WindowRenderer is valid for this window.
void | onReadOnlyChanged (WindowEventArgs &e)
| Handler called when the read-only state of the edit box changes.
void | onWordWrapModeChanged (WindowEventArgs &e)
| Handler called when the word wrap mode for the the edit box changes.
void | onMaximumTextLengthChanged (WindowEventArgs &e)
| Handler called when the maximum text length for the edit box changes.
void | onCaratMoved (WindowEventArgs &e)
| Handler called when the carat moves.
void | onTextSelectionChanged (WindowEventArgs &e)
| Handler called when the text selection changes.
void | onEditboxFullEvent (WindowEventArgs &e)
| Handler called when the edit box is full.
void | onVertScrollbarModeChanged (WindowEventArgs &e)
| Handler called when the 'always show' setting for the vertical scroll bar changes.
void | onHorzScrollbarModeChanged (WindowEventArgs &e)
| Handler called when 'always show' setting for the horizontal scroll bar changes.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseButtonUp (MouseEventArgs &e)
| Handler called when a mouse button has been released within this window's area.
virtual void | onMouseDoubleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been double-clicked within this window's area.
virtual void | onMouseTripleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been triple-clicked within this window's area.
virtual void | onMouseMove (MouseEventArgs &e)
| Handler called when the mouse cursor has been moved within this window's area.
virtual void | onCaptureLost (WindowEventArgs &e)
| Handler called when this window loses capture of mouse inputs.
virtual void | onCharacter (KeyEventArgs &e)
| Handler called when a character-key has been pressed while this window has input focus.
virtual void | onKeyDown (KeyEventArgs &e)
| Handler called when a key as been depressed while this window has input focus.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
virtual void | onSized (WindowEventArgs &e)
| Handler called when the window's size changes.
virtual void | onMouseWheel (MouseEventArgs &e)
| Handler called when the mouse wheel (z-axis) position changes within this window's area.
## Protected Attributes
bool | d_readOnly
| true if the edit box is in read-only mode
size_t | d_maxTextLen
| Maximum number of characters for this Editbox.
size_t | d_caratPos
| Position of the carat / insert-point.
size_t | d_selectionStart
| Start of selection area.
size_t | d_selectionEnd
| End of selection area.
bool | d_dragging
| true when a selection is being dragged.
size_t | d_dragAnchorIdx
| Selection index for drag selection anchor point.
bool | d_wordWrap
| true when formatting uses word-wrapping.
LineList | d_lines
| Holds the lines for the current formatting.
float | d_widestExtent
| Holds the extent of the widest line as calculated in the last formatting pass.
bool | d_forceVertScroll
| true if vertical scrollbar should always be displayed
bool | d_forceHorzScroll
| true if horizontal scrollbar should always be displayed
const Image * | d_selectionBrush
| Image to use as the selection brush (should be set by derived class).
## Static Protected Attributes
static String | d_lineBreakChars
| Holds what we consider to be line break characters.

## Detailed Description

Base class for the multi-line edit box widget.

## Member Function Documentation

void CEGUI::MultiLineEditbox::eraseSelectedText | ( | bool | modify_text = `true` | ) | `[protected]`

Erase the currently selected text.

Parameters:

  modify_text | when true, the actual text will be modified. When false, everything is done except erasing the characters.

void CEGUI::MultiLineEditbox::formatText | ( | const bool | update_scrollbars | ) | `[protected]`

Format the text into lines as dictated by the formatting options.

Parameters:

  update_scrollbars | true if scrollbar configuration should be performed. false if scrollbar configuration should not be performed.

void CEGUI::MultiLineEditbox::formatText | ( | void |  | ) | `[protected]`

Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.

Returns:
  Rect object describing the area of the Window to be used for rendering text.

Format the text into lines as needed by the current formatting options.

Deprecated:
  This is deprecated in favour of the version taking a boolean.

size_t CEGUI::MultiLineEditbox::getCaratIndex | ( | void |  | ) | const`[inline]`

return the current position of the carat.

Returns:
  Index of the insert carat relative to the start of the text.

Scrollbar* CEGUI::MultiLineEditbox::getHorzScrollbar | ( |  | ) | const

Return a pointer to the horizontal scrollbar component widget for this MultiLineEditbox.

Returns:
  Pointer to a Scrollbar object.

Exceptions:

  UnknownObjectException | Thrown if the horizontal Scrollbar component does not exist.

size_t CEGUI::MultiLineEditbox::getMaxTextLength | ( | void |  | ) | const`[inline]`

return the maximum text length set for this edit box.

Returns:
  The maximum number of code points (characters) that can be entered into this edit box.

size_t CEGUI::MultiLineEditbox::getNextTokenLength | ( | const String & | text,
|  | size_t | start_idx
| ) |  | const`[protected]`

Return the length of the next token in String text starting at index start_idx.

Note:
  Any single whitespace character is one token, any group of other characters is a token.

Returns:
  The code point length of the token.

size_t CEGUI::MultiLineEditbox::getSelectionEndIndex | ( | void |  | ) | const

return the current selection end point.

Returns:
  Index of the selection end point relative to the start of the text. If no selection is defined this function returns the position of the carat.

size_t CEGUI::MultiLineEditbox::getSelectionLength | ( | void |  | ) | const

return the length of the current selection (in code points / characters).

Returns:
  Number of code points (or characters) contained within the currently defined selection.

size_t CEGUI::MultiLineEditbox::getSelectionStartIndex | ( | void |  | ) | const

return the current selection start point.

Returns:
  Index of the selection start point relative to the start of the text. If no selection is defined this function returns the position of the carat.

size_t CEGUI::MultiLineEditbox::getTextIndexFromPosition | ( | const Point & | pt | ) | const`[protected]`

Return the text code point index that is rendered closest to screen position pt.

Parameters:

  pt | Point object describing a position on the screen in pixels.

Returns:
  Code point index into the text that is rendered closest to screen position pt.

Rect CEGUI::MultiLineEditbox::getTextRenderArea | ( | void |  | ) | const

Return a Rect object describing, in un-clipped pixels, the window relative area that the text should be rendered in to.

Returns:
  Rect object describing the area of the Window to be used for rendering text.

Scrollbar* CEGUI::MultiLineEditbox::getVertScrollbar | ( |  | ) | const

Return a pointer to the vertical scrollbar component widget for this MultiLineEditbox.

Returns:
  Pointer to a Scrollbar object.

Exceptions:

  UnknownObjectException | Thrown if the vertical Scrollbar component does not exist.

bool CEGUI::MultiLineEditbox::hasInputFocus | ( | void |  | ) | const

return true if the edit box has input focus.

Returns:
  - true if the edit box has keyboard input focus.
  - false if the edit box does not have keyboard input focus.

virtual void CEGUI::MultiLineEditbox::initialiseComponents | ( | void |  | ) | `[virtual]`

Initialise the Window based object ready for use.

Note:
  This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window type.

Returns:
  Nothing

Reimplemented from CEGUI::Window.

bool CEGUI::MultiLineEditbox::isReadOnly | ( | void |  | ) | const`[inline]`

return true if the edit box is read-only.

Returns:
  - true if the edit box is read only and can't be edited by the user.
  - false if the edit box is not read only and may be edited by the user.

bool CEGUI::MultiLineEditbox::isVertScrollbarAlwaysShown | ( | void |  | ) | const

Return whether the vertical scroll bar is always shown.

Returns:
  - true if the scroll bar will always be shown even if it is not required.
  - false if the scroll bar will only be shown when it is required.

bool CEGUI::MultiLineEditbox::isWordWrapped | ( | void |  | ) | const

Return whether the text in the edit box will be word-wrapped.

Returns:
  - true if the text will be word-wrapped at the edges of the widget frame.
  - false if text will not be word-wrapped (a scroll bar will be used to access long text lines).

virtual void CEGUI::MultiLineEditbox::onCaptureLost | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window loses capture of mouse inputs.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onCharacter | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

Handler called when a character-key has been pressed while this window has input focus.

Parameters:

  e | KeyEventArgs object whose 'codepoint' field is set to the Unicode code point (encoded as utf32) for the character typed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onKeyDown | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

Handler called when a key as been depressed while this window has input focus.

Parameters:

  e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was pressed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been depressed within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseButtonUp | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been released within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseDoubleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been double-clicked within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseMove | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has been moved within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseTripleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been triple-clicked within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onMouseWheel | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse wheel (z-axis) position changes within this window's area.

Parameters:

  e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onSized | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's size changes.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented from CEGUI::Window.

virtual void CEGUI::MultiLineEditbox::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's text is changed.

Parameters:

  e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented from CEGUI::Window.

void CEGUI::MultiLineEditbox::setCaratIndex | ( | size_t | carat_pos | ) |

Set the current position of the carat.

Parameters:

  carat_pos | New index for the insert carat relative to the start of the text. If the value specified is greater than the number of characters in the edit box, the carat is positioned at the end of the text.

Returns:
  Nothing.

void CEGUI::MultiLineEditbox::setMaxTextLength | ( | size_t | max_len | ) |

set the maximum text length for this edit box.

Parameters:

  max_len | The maximum number of code points (characters) that can be entered into this Editbox.

Returns:
  Nothing.

void CEGUI::MultiLineEditbox::setReadOnly | ( | bool | setting | ) |

Specify whether the edit box is read-only.

Parameters:

  setting | true if the edit box is read only and can't be edited by the user. false if the edit box is not read only and may be edited by the user.

Returns:
  Nothing.

void CEGUI::MultiLineEditbox::setSelection | ( | size_t | start_pos,
|  | size_t | end_pos
| ) |  |

Define the current selection for the edit box.

Parameters:

  start_pos | Index of the starting point for the selection. If this value is greater than the number of characters in the edit box, the selection start will be set to the end of the text.
  end_pos | Index of the ending point for the selection. If this value is greater than the number of characters in the edit box, the selection start will be set to the end of the text.

Returns:
  Nothing.

void CEGUI::MultiLineEditbox::setShowVertScrollbar | ( | bool | setting | ) |

Set whether the vertical scroll bar should always be shown.

Parameters:

  setting | true if the vertical scroll bar should be shown even when it is not required. false if the vertical scroll bar should only be shown when it is required.

Returns:
  Nothing.

void CEGUI::MultiLineEditbox::setWordWrapping | ( | bool | setting | ) |

Set whether the text will be word wrapped or not.

Parameters:

  setting | true if the text should word-wrap at the edges of the text box. false if the text should not wrap, but a scroll bar should be used.

Returns:
  Nothing.

virtual bool CEGUI::MultiLineEditbox::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

Return whether this window was inherited from the given class name at some point in the inheritance hierarchy.

Parameters:

  class_name | The class name that is to be checked.

Returns:
  true if this window was inherited from class_name. false if not.

Reimplemented from CEGUI::Window.

References CEGUI::Window::testClassName_impl().

virtual bool CEGUI::MultiLineEditbox::validateWindowRenderer | ( | const String & | name | ) | const`[inline, protected, virtual]`

Function used in checking if a WindowRenderer is valid for this window.

Returns:
  Returns true if the given WindowRenderer class name is valid for this window. False if not.

Reimplemented from CEGUI::Window.

## Member Data Documentation

const String CEGUI::MultiLineEditbox::EventCaratMoved`[static]`

Event fired when the text caret / current insertion position is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose caret position has changed.

const String CEGUI::MultiLineEditbox::EventEditboxFull`[static]`

Event fired when the number of characters in the edit box reaches the current maximum length. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose text length has reached the set maximum allowable length for the edit box.

const String CEGUI::MultiLineEditbox::EventHorzScrollbarModeChanged`[static]`

Event fired when the mode setting that forces the display of the horizontal scroll bar for the edit box is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose horizontal scrollbar mode has been changed.

const String CEGUI::MultiLineEditbox::EventMaximumTextLengthChanged`[static]`

Event fired when the maximum allowable string length for the edit box has been changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose maximum string length was changed.

const String CEGUI::MultiLineEditbox::EventReadOnlyModeChanged`[static]`

Event fired when the read-only mode for the edit box has been changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose read-only mode was changed.

const String CEGUI::MultiLineEditbox::EventTextSelectionChanged`[static]`

Event fired when the current text selection for the edit box is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose text selection was changed.

const String CEGUI::MultiLineEditbox::EventVertScrollbarModeChanged`[static]`

Event fired when the mode setting that forces the display of the vertical scroll bar for the edit box is changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose vertical scrollbar mode has been changed.

const String CEGUI::MultiLineEditbox::EventWordWrapModeChanged`[static]`

Event fired when the word wrap mode of the edit box has been changed. Handlers are passed a const WindowEventArgs reference with WindowEventArgs::window set to the MultiLineEditbox whose word wrap mode was changed.